searchNodes=[{"doc":"Documentation for Castle .","ref":"Castle.html","title":"Castle","type":"module"},{"doc":"","ref":"Castle.html#commit/1","title":"Castle.commit/1","type":"function"},{"doc":"","ref":"Castle.html#generate/1","title":"Castle.generate/1","type":"function"},{"doc":"","ref":"Castle.html#install/1","title":"Castle.install/1","type":"function"},{"doc":"","ref":"Castle.html#make_releases/0","title":"Castle.make_releases/0","type":"function"},{"doc":"","ref":"Castle.html#post_assemble/1","title":"Castle.post_assemble/1","type":"function"},{"doc":"","ref":"Castle.html#pre_assemble/1","title":"Castle.pre_assemble/1","type":"function"},{"doc":"","ref":"Castle.html#releases/0","title":"Castle.releases/0","type":"function"},{"doc":"","ref":"Castle.html#remove/1","title":"Castle.remove/1","type":"function"},{"doc":"","ref":"Castle.html#unpack/1","title":"Castle.unpack/1","type":"function"},{"doc":"Generate a relup file between releases. castle.relup will generate a relup between a target release and any number of other releases. The paths specifed in the options should be the paths to .rel files (but without the .rel extension) Command-line options: --target - the path to the .rel file in the target release --fromto - the path to the .rel file from a previous release --upfrom - the path to the .rel file from a previous release --downto - the path to the .rel file from a previous release --outdir - the directory to write the relup. Defaults to the current directory The --fromto , --upfrom and --downto switches may be specified zero or more times and have the following behaviour: --fromto generates both upgrade and downgrade instructions --upfrom generates only upgrade instructions --downto generates only downgrade instructions","ref":"Mix.Tasks.Castle.Relup.html","title":"Mix.Tasks.Castle.Relup","type":"task"},{"doc":"Compiles appup files into the application's ebin folder.","ref":"Mix.Tasks.Compile.Appup.html","title":"Mix.Tasks.Compile.Appup","type":"task"},{"doc":"Hot-code upgrade support for Elixir Releases. Castle provides build and runtime support for the generation of releases that correctly support hot-code upgrades. This includes: Generation of runtime configuration into sys.config prior to system boot. Creation of the RELEASES file on first boot. Support for appup and relup files. Shell-script support for managing upgrades.","ref":"readme.html","title":"Castle","type":"extras"},{"doc":"The package can be installed by adding castle to your list of dependencies in mix.exs : def deps do [ { :castle , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"Castle - Installation","type":"extras"},{"doc":"Castle integrates into the steps of the release assembly process. It requires that the Castle.pre_assemble/1 and Castle.post_assemble/1 functions are placed around the :assemble step, e.g.: defp releases do [ myapp : [ include_executables_for : [ :unix ] , steps : [ &amp; Castle . pre_assemble / 1 , :assemble , &amp; Castle . post_assemble / 1 , :tar ] ] ] end","ref":"readme.html#integration","title":"Castle - Integration","type":"extras"},{"doc":"The following steps shape the release at build-time: Pre-assembly In the pre-assembly step: The default evaluation of runtime configuration is disabled. Castle will do its own equivalent expansion into sys.config prior to system start, first with runtime.exs (if it exists) and then with any Config Providers. A 'preboot' boot script is created that starts only Castle and its dependencies. This is used only during the aforementioned expansion. The system is then assembled under the :assemble step as normal. Post-assembly In the post-assembly step: The sys.config generated from build-time configuration is copied to build.config . The shell-script in the bin folder is renamed from name to .name , and a new script called name is created in its place. This new script will ensure that the sys.config is correctly generated before the system is started. Any runtime.exs is copied into the version path of the release. The generated name.rel is copied into the releases folder as name-vsn.rel . Any relup file is copied into the version path of the release.","ref":"readme.html#build-time-support","title":"Castle - Build Time Support","type":"extras"},{"doc":"At runtime, the script in the bin folder will intercept any calls to start , start_iex , daemon and daemon_iex and bring up an ephemeral node to generate sys.config by merging build.config with the results of evaluating runtime.exs and any Config Providers. Additionally, this ephemeral node will create the RELEASES file if it does not already exist.","ref":"readme.html#runtime-support","title":"Castle - Runtime Support","type":"extras"},{"doc":"The script in the bin folder supports some extra commands to manage upgrades. Releases, in their tarred-gzipped form, should first be copied to the releases subfolder on the target system. The following commands can be used to manage them: releases - Lists the releases on the system and their status. Status can be one of the following: permanent - the release the system will boot into on next restart. current - if it exists, represents the current running release. Will be different from the permanent version if a new release has been installed but not yet committed. If no version is listed as current, the permanent version is the currently running version. old - if it exists, a previously installed version. unpacked - an unpacked version, but not yet installed. unpack &lt;vsn&gt; - Unpacks the release called &lt;name&gt;-&lt;vsn&gt;.tar.gz . install &lt;vsn&gt; - Installs the new release. This makes the release the current one, but not yet the permanent one. Prior to running the relup, Castle generates the version specific sys.config for the new version. commit &lt;vsn&gt; - Makes the specified release the one the permanent one. remove &lt;vsn&gt; - Remove an old version from the filesystem. Any files shared with remaining releases are left untouched.","ref":"readme.html#release-management","title":"Castle - Release Management","type":"extras"},{"doc":"You are responsible for writing the appup scripts for your application, but Castle will copy the appup into the ebin folder for you. The steps are as follows: Write a file, in Elixir form , describing the application upgrade. e.g.: # You can call the file what you like, e.g. appup.ex, # but you should # keep it away from the compiler paths. { &#39;0.1.1&#39; , [ { &#39;0.1.0&#39; , [ { :update , MyApp.Server , { :advanced , [ ] } } ] } ] , [ { &#39;0.1.0&#39; , [ { :update , MyApp.Server , { :advanced , [ ] } } ] } ] } This file will typically be checked in to SCM. Add the appup file to the Mix project definition in mix.exs and add the :appup compiler. # Mix.exs def project do [ appup : &quot;appup.ex&quot; , # Relative to the project root. compilers : Mix . compilers ( ) ++ [ :appup ] ] end","ref":"readme.html#the-appup-compiler","title":"Castle - The Appup Compiler","type":"extras"},{"doc":"Castle contains a mix task, castle.relup , that simplifies the generation of the relup file. Assuming you have two unpacked releases e.g. 0.1.0 and 0.1.1 and you wish to generate a relup between them: &gt; mix castle.relup --target myapp/releases/0.1.1/myapp --fromto myapp/releases/0.1.0/myapp If the generated file is in the project root, it will be copied during post-assembly to the release.","ref":"readme.html#relup-generation","title":"Castle - Relup Generation","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Update Changelog","ref":"changelog.html#0-2-2-may-21-2023","title":"Changelog - 0.2.2 - May 21, 2023","type":"extras"},{"doc":"Update README","ref":"changelog.html#0-2-1-may-21-2023","title":"Changelog - 0.2.1 - May 21, 2023","type":"extras"},{"doc":"Added support for Config Provider expansion","ref":"changelog.html#0-2-0-may-21-2023","title":"Changelog - 0.2.0 - May 21, 2023","type":"extras"},{"doc":"Initial revision","ref":"changelog.html#0-1-3-may-16-2023","title":"Changelog - 0.1.3 - May 16, 2023","type":"extras"}]